package es.rediris.forja.jleon.arrivalert;

import java.util.ArrayList;

import android.app.Activity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;



public class AdaptarElementos extends BaseAdapter {
	
    private final Activity actividad;
    private final ArrayList<IListaElementos> lista;


    
public AdaptarElementos(Activity actividad, ArrayList<IListaElementos> lista) {
	
    super();
    this.actividad = actividad;
    this.lista = lista;
}
    
    
   public View getView(int indice, View v, ViewGroup vg) {
    	
     LayoutInflater inflater = actividad.getLayoutInflater();
     View velem = inflater.inflate(R.layout.plantilla, null, true);
          
     /** Elemento a configurar **/
     IListaElementos elem = this.lista.get(indice);
          
     /** Configuracin del elemento **/
     ImageView imageView = (ImageView)velem.findViewById(R.id.icono);
     TextView titulo = (TextView)velem.findViewById(R.id.titulo);
     TextView subTitulo = (TextView)velem.findViewById(R.id.subtitulo);
          
     /** Rellenando elemento **/
     titulo.setText(elem.getElementoPrincipal());          
     subTitulo.setText(elem.getElementoSecundario());
     imageView.setImageResource(elem.getElementoImagenID());
          
     return velem;
   }


    @Override
    public int getCount() {
        return lista.size();
    }

    @Override 
    public Object getItem(int indice) {
      return lista.get(indice);
    }


    @Override 
    public long getItemId(int indice) {
    	if(indice >= 0 && indice < lista.size())
    		return lista.get(indice).getId();
        return -1;
    }
}