package es.rediris.forja.jleon.arrivalert;

import java.util.ArrayList;



import android.app.ListActivity;
import android.content.Intent;
import android.os.Bundle;
import android.view.ContextMenu;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.Window;
import android.view.ContextMenu.ContextMenuInfo;
import android.widget.AdapterView;
import android.widget.ListView;
import android.widget.TextView;


public class AlertaIMActivity extends ListActivity {
	
	private AdaptarElementos mAdaptador;
	private int mode;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		this.setContentView(R.layout.alertaim);
		
		refreshAdaptador();
		
	    ListView list = (ListView)this.findViewById(android.R.id.list);
	    registerForContextMenu(list);
	    
		Bundle extras = this.getIntent().getExtras();
		int m = extras == null ? -1 : extras.getInt(Constantes.CTE_MODO);
		if(m == Constantes.CTE_SELECCION)
			this.mode = Constantes.CTE_SELECCION;
		else
			this.mode = Constantes.CTE_VISTA;
		
		// seleccionar otros valores
		if(this.mode == Constantes.CTE_SELECCION) {
				// Ponemos los valores en los TextView
				((TextView)findViewById(R.id.lblHeader)).setText(getString(R.string.str_select_action));
		}
	}
	
	private void refreshAdaptador() {
		
        BDAlerta bbdd = new BDAlerta(this);
        
        // Adaptador 
        ArrayList<IListaElementos> list = new ArrayList<IListaElementos>(bbdd.getAllAccionMail()); // tenemos que convertir el tipo de lista
        this.mAdaptador = new AdaptarElementos(this, list);
        
        setListAdapter(this.mAdaptador);
        
        bbdd.close();
	}
	
	
	public void onClickOnAdd(View v) {
        Intent i = new Intent(this, RegistroAlertaIMActivity.class);
        this.startActivityForResult(i, Constantes.CTE_REG_ALERTA);
	}
	
	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		if(resultCode == RESULT_OK && requestCode == Constantes.CTE_REG_ALERTA) {
			refreshAdaptador(); //refrescar BD
		}
	}
	
	
	@Override 
	protected void onListItemClick(ListView listView, View view, int position, long id) {
		super.onListItemClick(listView, view, position, id);
		
		Object o = getListAdapter().getItem(position); 								
		AlertaIM a = (AlertaIM)o;
		
		if(this.mode == Constantes.CTE_SELECCION)
			seleccionarAccion(a);
		else
			editAccion(a);
	}
	
	
	private void seleccionarAccion(AlertaIM a) {
		Intent i = new Intent();
		i.putExtra(Constantes.CTE_ALERTA_NOMBRE, a.getNombre());
		i.putExtra(Constantes.CTE_ALERTA_ID, a.getId());
		i.putExtra(Constantes.CTE_ALERTA_IM, a.getAlertarID());
		this.setResult(RESULT_OK, i);
		this.finish();
	}
	
	private void editAccion(AlertaIM a) {
		  Intent i = new Intent(this, RegistroAlertaIMActivity.class);
		  i.putExtra(Constantes.CTE_ALERTA_ID, a.getId());  
	      this.startActivityForResult(i, Constantes.CTE_REG_ALERTA);
	}
	
	
	
	// Men contextual
	
	@Override
	public void onCreateContextMenu(ContextMenu menu, View v, ContextMenuInfo menuInfo) {
		if (v.getId()==android.R.id.list) {
			AdapterView.AdapterContextMenuInfo info = (AdapterView.AdapterContextMenuInfo)menuInfo;
			AlertaIM a = (AlertaIM)this.mAdaptador.getItem(info.position);
			menu.setHeaderTitle(a.getNombre());
			
			// Opciones
			menu.add(Menu.NONE, 0, 0, R.string.str_select);
			menu.add(Menu.NONE, 1, 1, R.string.str_delete);
			menu.add(Menu.NONE, 2, 2, R.string.str_edit);
			menu.add(Menu.NONE, 3, 3, R.string.str_execute_now);
		}
	}
	
	
	@Override
	public boolean onContextItemSelected(MenuItem item) {
	  AdapterView.AdapterContextMenuInfo info = (AdapterView.AdapterContextMenuInfo)item.getMenuInfo();
	  int menuItemId = item.getItemId();
	  AlertaIM a = (AlertaIM)this.mAdaptador.getItem(info.position);
	  
	  //seleccionar
	  if(menuItemId == 0) {
		  seleccionarAccion(a);
	  }
	  //eliminar
	  else if (menuItemId == 1) {
			// Borramos la fila de la base de datos
		    BDAlerta bbdd = new BDAlerta(this);
	        bbdd.deleteAccion(a);	        
	        bbdd.close();
	        
	        // refrescamos nuestra lista
	        refreshAdaptador();
	  }
	  else if (menuItemId == 2) {
		  	editAccion(a);
	  }
	  else if (menuItemId == 3) {
		  a.operar(this, Preferencias.getEnable(this));
	  }
	  
	  return true;
	}
	
}
