package es.rediris.forja.jleon.arrivalert;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.widget.Toast;
import java.util.Calendar;
import java.util.Date;

public class AlertaReceiver extends BroadcastReceiver {

   public void onReceive(Context ctxt, Intent intn) {
      Date fch = new Date();
      Toast.makeText(ctxt, "Alerta recibida: " + fch.toGMTString(), 1).show();
      Bundle bund = intn.getExtras();
      
      if(bund != null) {
         int evid = bund.getInt(Constantes.CTE_EVENTO_ID);
         
         if(evid > 0) {
            Evento ev = BDEvento.getCita(ctxt, evid);
            
            if(ev != null) {
               Calendar cal = Calendar.getInstance();
               cal.add(12, -1);
               long tmp = cal.getTimeInMillis();
               cal.add(12, 2);
               long tmp2 = cal.getTimeInMillis();
               long tmpalerta = ev.getFechaAlerta().getTime();
               
               if(tmpalerta >= tmp && tmpalerta <= tmp2) {
                  Intent intencion = new Intent(ctxt, ArrivAlertService.class);
                  intencion.putExtra(Constantes.CTE_EVENTO_ID, evid);
                  ctxt.startService(intencion);
               }
            }
         }
      }

   }
}
