package es.rediris.forja.jleon.arrivalert;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.Window;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.Toast;


public class ArrivAlertActivity extends Activity implements OnClickListener {
    
    private Button btEventos;
    private Button btUbicaciones;
    private Button btAlertas;
    private Button btOpciones;
	
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
    	
        super.onCreate(savedInstanceState);
        requestWindowFeature(Window.FEATURE_NO_TITLE);
        setContentView(R.layout.main);
        
        this.btEventos = (Button)findViewById(R.id.btEventos);
        this.btUbicaciones = (Button)findViewById(R.id.btUbicaciones);
        this.btAlertas = (Button)findViewById(R.id.btAlertas);
        this.btOpciones = (Button)findViewById(R.id.btOpciones);
        
        this.btEventos.setOnClickListener(this);
        this.btUbicaciones.setOnClickListener(this);
        this.btOpciones.setOnClickListener(this);
        this.btAlertas.setOnClickListener(this);
        
        IniciarContexto();
    }
    
    
    public void IniciarContexto() {
    	
    	/** Esto evita usar un contexto propio **/
    	
    	Evento.STR_ESTADO_LLEGAS_TARDE = getString(R.string.str_estado_tarde);
    	Evento.STR_ESTADO_TRATADA = getString(R.string.str_estado_tratada);
    	Evento.STR_ESTADO_NO_TRATADA = getString(R.string.str_estado_no_tratada);
    	Evento.STR_ESTADO_LLEGAS_EN_HORA = getString(R.string.str_estado_hora);
    }
    
    
    
    @Override
    public void onClick(View v) {
    	     if (this.btEventos == v) onClickbtEventos(v);
    	else if (this.btUbicaciones == v) onClickbtUbicaciones(v);
    	else if (this.btAlertas == v) onClickOnbtAlertas(v);
    	else if (this.btOpciones == v) onClickOnbtOpciones(v);
    }
    
    
    public void onClickbtEventos(View v) {
    	Intent i = new Intent(this, CalendarioEventosActivity.class);        
        this.startActivityForResult(i, Constantes.CTE_EVENTO);
    }
    
    public void onClickbtUbicaciones(View v) {
        Intent i = new Intent(this, UbicacionesActivity.class);        
        this.startActivityForResult(i, Constantes.CTE_UBICACION);
    }
    
    public void onClickOnbtAlertas(View v) {
        Intent i = new Intent(this, AlertaIMActivity.class);        
        this.startActivityForResult(i, Constantes.CTE_ALERTA);
    }
    
    public void onClickOnbtOpciones(View v) {
        Intent i = new Intent(this, PreferenciasActivity.class);        
        this.startActivityForResult(i, Constantes.CTE_OPCIONES);
    }
    
    
    public void clickOnManual(View v) {
    	Intent i = new Intent(this, ManualActivity.class);
        startActivity(i);
    }
    
    public void clickOnAbout(View v) {
    	Intent i = new Intent(this, AcercaDeActivity.class);
    	startActivity(i);
    	//TODO: Sustituir por lanzarActividad
    }
    
    public void clickOnExit(View v) {
    	lanzarSalir();
    }
    
    
	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		String s = "";
		
		if(resultCode == RESULT_OK && requestCode == Constantes.CTE_EVENTO) {
			String nombre_cita = data.getExtras().getString(Constantes.CTE_EVENTO_NOMBRE);
			int id_cita = data.getExtras().getInt(Constantes.CTE_EVENTO_ID);
			
			s = String.format("Evento id = %s, nombre = %s", id_cita, nombre_cita);
		}
		
		
		else if(resultCode == RESULT_OK && requestCode == Constantes.CTE_UBICACION) {
			String nombre_lugar = data.getExtras().getString(Constantes.CTE_UBICACION_NOMBRE);
			int id_lugar = data.getExtras().getInt(Constantes.CTE_UBICACION_ID);
			
			s = String.format("Lugar id = %s, nombre = %s", id_lugar, nombre_lugar);
			
		}
		
		
		else if(resultCode == RESULT_OK && requestCode == Constantes.CTE_ALERTA) {
			String nombre_accion = data.getExtras().getString(Constantes.CTE_ALERTA_NOMBRE);
			int id_accion = data.getExtras().getInt(Constantes.CTE_ALERTA_ID);
			
			s = String.format("AccionMail id = %s, nombre = %s", id_accion, nombre_accion);
		}
		
		
		else if(resultCode == RESULT_OK && requestCode == Constantes.CTE_OPCIONES) {
			String nombre_accion = data.getExtras().getString(Constantes.CTE_ALERTA_NOMBRE);
			int id_accion = data.getExtras().getInt(Constantes.CTE_ALERTA_ID);
			
			s = String.format("AccionSms id = %s, nombre = %s", id_accion, nombre_accion);
		}
		
		
		if(resultCode == RESULT_OK)
			Toast.makeText(this, s, Toast.LENGTH_SHORT).show();
	}
	
	
	 /** 
	  * Men contextual 
	  */
	 
	
    @Override 
    public boolean onCreateOptionsMenu(Menu menu) {
        super.onCreateOptionsMenu(menu);
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.menu, menu);

        return true; 
     }
    

     @Override 
     public boolean onOptionsItemSelected(MenuItem item) {
         switch (item.getItemId()) {
         	case R.id.botonManual: 
         		lanzarActividad(ManualActivity.class);
         		break;
         		
         	case R.id.botonAcercaDe:    
         		clickOnAbout(null);     
         		break;
         		
         	case R.id.botonSalir:
         		clickOnExit(null);     
         		break;
         }

         return true; 
     }
	
	
     private void lanzarActividad(Class<?> clase) {   
       	Intent i = new Intent(this, clase);
       	startActivity(i);
       }
       
       
       private void lanzarSalir() {			
   		this.finish();
   	}
       
       
       protected void onDestroy() {
       	super.onDestroy();
   		
   	}
     
	
}