package es.rediris.forja.jleon.arrivalert;

import android.app.AlarmManager;
import android.app.PendingIntent;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.widget.Toast;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.Iterator;

public class ArrivAlertReceiver extends BroadcastReceiver {

   private static Hashtable<Integer, PendingIntent> alarmasFinales = new Hashtable<Integer, PendingIntent>();
   private static Hashtable<Integer, PendingIntent> alarmasAlertas = new Hashtable<Integer, PendingIntent>();


   public static void EliminarAlertas(Context c, Evento ev) {
      AlarmManager alarma = (AlarmManager)c.getSystemService("alarm");
      Integer evID = Integer.valueOf(ev.getId());
      if(alarmasFinales.containsKey(evID)) {
         alarma.cancel((PendingIntent)alarmasFinales.get(evID));
         alarmasFinales.remove(evID);
         Toast.makeText(c, "Alerta eliminada (1)", 0).show();
      }

      if(alarmasAlertas.containsKey(evID)) {
         alarma.cancel((PendingIntent)alarmasAlertas.get(evID));
         alarmasAlertas.remove(evID);
         Toast.makeText(c, "Alerta eliminada (2)", 0).show();
      }

   }

   

   public static void ProgramarAlertas(Context var0, Evento var1) {
      if(var1.getEstado() == 2) {
         AlarmManager var2 = (AlarmManager)var0.getSystemService("alarm");
         Integer var3 = Integer.valueOf(var1.getId());
         if(alarmasAlertas.containsKey(var3)) {
            var2.cancel((PendingIntent)alarmasAlertas.get(var3));
            Toast.makeText(var0, "Alerta reprogramada (1)", 0).show();
         }

         Intent var4 = new Intent(var0, AlertaReceiver.class);
         var4.putExtra(Constantes.CTE_EVENTO_ID, var1.getId());
         PendingIntent var6 = PendingIntent.getBroadcast(var0, 7777, var4, PendingIntent.FLAG_ONE_SHOT);
         var2.set(1, var1.getFechaAlerta().getTime(), var6);
         alarmasAlertas.put(var3, var6);
         Toast.makeText(var0, "Alerta programada (1): " + var1.toString(), 1).show();
      }

   }

   
   public static void ReProgramarAlertas(Context var0, Evento var1) {
	      int var2 = var1.getEstado();
	      if(var2 == 4 || var2 == 3) {
	         AlarmManager var3 = (AlarmManager)var0.getSystemService("alarm");
	         Integer var4 = Integer.valueOf(var1.getId());
	         if(alarmasFinales.containsKey(var4)) {
	            var3.cancel((PendingIntent)alarmasFinales.get(var4));
	            Toast.makeText(var0, "Alerta reprogramada (2)", 0).show();
	         }

	         Intent var5 = new Intent(var0, AlertaPosteriorReceiver.class);
	         var5.putExtra(Constantes.CTE_EVENTO_ID, var1.getId());
	         PendingIntent var7 = PendingIntent.getBroadcast(var0, 8888, var5, PendingIntent.FLAG_ONE_SHOT);
	         var3.set(1, var1.getFecha().getTime(), var7);
	         alarmasFinales.put(var4, var7);
	         Toast.makeText(var0, "Alerta programada (2): " + var1.toString(), 1).show();
	      }

	   }
   
   public void onReceive(Context var1, Intent var2) {
	   BDEvento var3 = new BDEvento(var1);
      ArrayList<Evento> var4 = var3.getAllCitas();
      var3.close();
      Iterator<Evento> var5 = var4.iterator();

      while(var5.hasNext()) {
         Evento var6 = (Evento)var5.next();
         if(var6.getEstado() == 2) {
        	 ProgramarAlertas(var1, var6);
         } else if(var6.getEstado() != 1) {
        	 ReProgramarAlertas(var1, var6);
         }
      }

   }
   
   
   
   
   
}
