package es.rediris.forja.jleon.arrivalert;


import java.util.ArrayList;

import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;

public class BDAlerta extends SQLiteOpenHelper {
	
	public BDAlerta(Context context) {	
		super(context, "bd_alerta", null, 1);	
	}
	
	// SQLiteOpenHelper methods
	
	@Override
	public void onCreate(SQLiteDatabase db) {
		
		
		db.execSQL("CREATE TABLE accion_mail ("+	
                       "_id INTEGER PRIMARY KEY AUTOINCREMENT, "+	
                       "nombre TEXT, mail_address TEXT, mail_subject TEXT, mail_content TEXT)");
	}
	
	
	@Override    
	public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {		
		// En caso de una nueva version	
	}	
	
	
	
	public void insertAccion(AlertaIM a) {	
		if(a==null)
			return;
		
		SQLiteDatabase db = getWritableDatabase();		
		String sql = String.format("INSERT INTO accion_mail VALUES (null, '%s', '%s', '%s', '%s')", 
				a.getNombre(), 
				a.getIMDireccion(), 
				a.getIMAsunto(),
				a.getIMContenido());
		
		db.execSQL(sql);
		db.close();
	}
	
	public void updateAccion(AlertaIM a) {	
		if(a==null)
			return;
		
		SQLiteDatabase db = getWritableDatabase();		
		String sql = String.format("UPDATE accion_mail SET nombre = '%s', mail_address = '%s', mail_subject = '%s', mail_content = '%s' WHERE _id = %s", 
				a.getNombre(), 
				a.getIMDireccion(), 
				a.getIMAsunto(),
				a.getIMContenido(),
				a.getId());
		
		db.execSQL(sql);
		db.close();
	}
	
	public void deleteAccionMail(int id) {	
		if(id < 1)
			return;
		
		SQLiteDatabase db = getWritableDatabase();		
		String sql = String.format("DELETE FROM accion_mail WHERE _id = %s", id);
		
		db.execSQL(sql);
		db.close();
	}
	
	public void deleteAccion(AlertaIM a) {	
		if(a != null)
			deleteAccionMail(a.getId());
	}
	
	public Alerta getAccionRetardo(int idTipoAccion, int idAccion) {
		switch(idTipoAccion) {
			
			case Alerta.ALERTA_IM: return this.getAccionMail(idAccion);
			default: return null;
		}
	}
	
	public AlertaIM getAccionMail(int id) {
		AlertaIM a = null;		
		SQLiteDatabase db  = getReadableDatabase();
		
		String sql = "SELECT _id, nombre, mail_address, mail_subject, mail_content FROM accion_mail WHERE _id = " + id;		
		Cursor cursor = db.rawQuery(sql, null);
				
		// solo una ubicacion
		if (cursor.moveToNext())
			a = new AlertaIM(cursor.getInt(0), 
						  			 cursor.getString(1),
						  			 cursor.getString(2),
						  			 cursor.getString(3),
						  			 cursor.getString(4));		
		
		cursor.close();
		db.close();
		
		return a;	
	}
	
	public ArrayList<AlertaIM> getAllAccionMail() {
		ArrayList<AlertaIM> list = new ArrayList<AlertaIM>();
		AlertaIM a = null;		
		SQLiteDatabase db = getReadableDatabase();
		
		String sql = "SELECT _id, nombre, mail_address, mail_subject, mail_content FROM accion_mail ORDER BY nombre ";		
		Cursor cursor = db.rawQuery(sql, null);
				
		// solo un lugar
		while (cursor.moveToNext())
		{
			a = new AlertaIM(cursor.getInt(0), 
						  			 cursor.getString(1),
						  			 cursor.getString(2),
						  			 cursor.getString(3),
						  			 cursor.getString(4));
			
			list.add(a);
		}
		
		cursor.close();
		db.close();
		
		return list;	
	}
	
}
