package es.rediris.forja.jleon.arrivalert;

import com.google.android.maps.GeoPoint;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.TextView;
import android.widget.Toast;


public class ConfiguraUbicacionActivity extends Activity
{
	
	// Atributos
	private Ubicacion l = null;
	
	
	@Override
	protected void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		this.setContentView(R.layout.configuraubicacion);
		
		// vemos si nos han pasado datos
		Bundle extras = this.getIntent().getExtras();
		int id = extras == null ? -1 : extras.getInt(Constantes.CTE_UBICACION_ID);
		
		if(id != 0)
		{
			// Modo editar un registro que ya existe en la bd
			BDUbicacion db = new BDUbicacion(this);
			this.l = db.getUbicacion(id);
			db.close();
			
			if(this.l != null)
			{
				// Ponemos los valores en los TextView
				((TextView)findViewById(R.id.txtName_editplaceForm)).setText(l.getNombre());
				((TextView)findViewById(R.id.txtDescription_editplaceForm)).setText(l.getDescripcion());
				((TextView)findViewById(R.id.txtAddress_editplaceForm)).setText(l.getDireccion());
				((TextView)findViewById(R.id.txtLat__editplaceForm)).setText(Double.toString(l.getLocation().getLatitudeE6()/1E6));
				((TextView)findViewById(R.id.txtLon_editplaceForm)).setText(Double.toString(l.getLocation().getLongitudeE6()/1E6));
			}
		}
	}
	
	
	public void onClickOnChoosePlace(View v)
	{
		// para seleccionar el punto en el mapa
		
        Intent i = new Intent(this, MapaActivity.class);
        i.putExtra(Constantes.CTE_MODO, MapaActivity.MODE_ADD);  // lo abrimos en modo anyadir nuevo punto, i.e. cuando hagamos click, recogerá el último punto pulsado
        this.startActivityForResult(i, Constantes.CTE_GUARDAR_UBICACION);
	}
	
	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data)
	{
		if(resultCode == RESULT_OK && requestCode == Constantes.CTE_GUARDAR_UBICACION)
		{
			String address = data.getExtras().getString(Constantes.CTE_DIRECCION);
			int lat        = data.getExtras().getInt(Constantes.CTE_LATITUD);
			int lon        = data.getExtras().getInt(Constantes.CTE_LONGITUD);
			
			if(this.l != null)
			{
				// update mode
				this.l.setDireccion(address);
				this.l.setLocation(new GeoPoint(lat, lon));
			}
			else
			{			
				// insert mode
				this.l = new Ubicacion(-1, "no_name", "no_desc", address, lat, lon);
			}
			
			((TextView)findViewById(R.id.txtAddress_editplaceForm)).setText(address);
			((TextView)findViewById(R.id.txtLat__editplaceForm)).setText(Double.toString(lat/1E6));
			((TextView)findViewById(R.id.txtLon_editplaceForm)).setText(Double.toString(lon/1E6));
		}
	}
	
	private boolean textIsNull(TextView txt)
	{
		if(txt.getText() == null)
			return true;
		return false;
	}
	
	private String getTextFromTxt(TextView txt)
	{
		if(textIsNull(txt))
			return "";
		else return (String)txt.getText().toString();
	}
	
	public void onClickOnOk_LugarEditor(View v)
	{
		// hemos hecho click en el ok
		
		TextView txtName = (TextView)findViewById(R.id.txtName_editplaceForm);
		TextView txtDesc = (TextView)findViewById(R.id.txtDescription_editplaceForm);
		
		String nombre = getTextFromTxt(txtName);
		String descri = getTextFromTxt(txtDesc);
		
		
		if(nombre == null || nombre.equals(""))
		{
			Toast.makeText(this, R.string.str_err_falta_nombre, Toast.LENGTH_SHORT).show();
			return;
		}
		
		if(this.l == null)
		{
			Toast.makeText(this, R.string.str_err_falta_location, Toast.LENGTH_SHORT).show();
			return;
		}
		
		// aquí ya no hay ningún error
		l.setNombre(nombre);
		l.setDescripcion(descri);
		
		BDUbicacion db = new BDUbicacion(this);
		
		if(this.l.getId() == -1)
			db.insertUbicacion(l); // insert mode
		else
			db.updateUbicacion(l); // update mode
			
		db.close();
		
		// terminamos la tarea
		this.setResult(RESULT_OK);
		this.finish();
	}
}
