package es.rediris.forja.jleon.arrivalert;

import java.io.IOException;
import java.util.List;
import java.util.Locale;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Point;
import android.location.Address;
import android.location.Geocoder;
import android.view.MotionEvent;
import android.widget.Toast;

import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapView;



 public class OverlayArrivAlert extends com.google.android.maps.Overlay {
	
    private MapView mapView; 
    private GeoPoint p;
    private String direccion;
    private Bitmap bmp;  
    
    public OverlayArrivAlert(MapView mapView) {
    	this.mapView = mapView;
    	this.bmp = BitmapFactory.decodeResource(mapView.getResources(), R.drawable.picaqui);
    	
    }
	
    @Override
    public boolean draw(Canvas canvas, MapView mapView,  boolean cliquea, long pulso) {
    	
        super.draw(canvas, mapView, cliquea);                   
        
        //Traduccion GeoPoint a pixeles
        
        if(p != null)
        {
	        Point screenPts = new Point();
	        mapView.getProjection().toPixels(p, screenPts);
	
	        //agregar marcador
	                    
	        canvas.drawBitmap(bmp, screenPts.x, screenPts.y-50, null);
        }
        
        return true;
    }
    
    
    //arrastrar o marcar
    
    private float   mX=0,   mY=0;
    private boolean disparo=false; 
    
    private void refrescarPosicion(float eventX, float eventY)
    {
        this.p = mapView.getProjection().fromPixels((int) eventX, (int) eventY);

        Geocoder geoCoder = new Geocoder(mapView.getContext(), Locale.getDefault());
        
        try 
        {
            List<Address> addresses = geoCoder.getFromLocation(p.getLatitudeE6()/1E6, p.getLongitudeE6() / 1E6, 1);

            this.direccion = "";
            if (addresses.size() > 0) 
            {
                for (int i=0; i<addresses.get(0).getMaxAddressLineIndex(); i++)
                   this.direccion += addresses.get(0).getAddressLine(i) + "\n";
            }

            this.mapView.invalidate();////
            Toast.makeText(mapView.getContext(), this.direccion, Toast.LENGTH_SHORT).show(); ///
        }
        catch (IOException e) 
        {                
            e.printStackTrace();
        } 
    }
    

    @Override
    public boolean onTouchEvent(MotionEvent event, MapView mapView) 
    {   
    	//super.onTouchEvent(event, mapView);  
    	
    	// nos ayudamos del codigo de Asteroides, para refrescar 
    	// solo si hacemos un click, no si arrastramos el dedo sobre la pantalla
    	// quedando este lejos de la posicion inicial donde hicimos el ACTION_DOWN
    	
    	
        float x = event.getX();
        float y = event.getY();
        
        switch (event.getAction()) 
        {
 	       case MotionEvent.ACTION_DOWN: disparo=true; break;
 	       case MotionEvent.ACTION_MOVE:
 	              float dx = Math.abs(x - mX);
 	              float dy = Math.abs(y - mY);
 	              if ((dy<6 && dx>6) || (dx<6 && dy>6))
 	              {
 	                    disparo = false;
 	              }
 	              break;
 	
 	       case MotionEvent.ACTION_UP:
 	              if (disparo)
 	              {
 	            	  refrescarPosicion(x, y);
 	              }
 	              break;
        }

        mX=x; mY=y;
        return false;
    }   
    
    
    
    
    
    public GeoPoint getGeoPoint()
    {
    	return this.p;
    }
    
    public String getDireccion()
    {
    	return this.direccion;
    }
}
