package es.rediris.forja.jleon.arrivalert;

import com.google.android.maps.GeoPoint;

public class Ubicacion implements Comparable<Ubicacion>, IListaElementos {
	
	private int id;
	private GeoPoint location;
	private String nombre;
	private String descripcion;
	private String direccion;
	
	
	public Ubicacion(int id,  String nombre, String descripcion, String direccion, GeoPoint location) {
		this.id = id;
		this.location = location;
		this.nombre = nombre;
		this.descripcion = descripcion;
		this.direccion = direccion;
	}
	
	public Ubicacion(int id,  String nombre, String descripcion, String direccion, int latitudeE6, int longitudeE6) {
		this(id, nombre, descripcion, direccion, new GeoPoint(latitudeE6, longitudeE6));
	}
	
	
	
	public int getId() {
		return id;
	}
	
	public void setId(int id) {
		this.id = id;
	}
	
	public GeoPoint getLocation() {
		return location;
	}
	
	public void setLocation(GeoPoint location) {
		this.location = location;
	}
	
	public String getNombre() {
		return nombre;
	}
	
	public void setNombre(String nombre) {
		this.nombre = nombre;
	}
	
	public String getDescripcion() {
		return descripcion;
	}
	
	public void setDescripcion(String descripcion) {
		this.descripcion = descripcion;
	}
	
	public String getDireccion() {
		return this.direccion;
	}
	
	public void setDireccion(String direccion) {
		this.direccion = direccion;
	}
	
	public String getUriString() {
		if(this.location != null)
		{
			double latitude  = this.location.getLatitudeE6() / 1E6;
			double longitude = this.location.getLongitudeE6() / 1E6;
			return String.format("geo:%s,%s?z=17&q=%s,%s(%s)", 
								 latitude,
								 longitude,
								 latitude,
								 longitude,
								 this.nombre);
		}
		
		else
			return "geo:0,0";

	}

	@Override
	public int compareTo(Ubicacion l) {
		return this.nombre.compareTo(l.nombre); // orden alfabético
	}
	
	@Override
	public String toString() {
		return String.format("Ubicacion [%s - %s - %s - %s]", 
				this.id,
				this.nombre,
				this.descripcion,
				this.direccion);
	}

	@Override
	public int getElementoImagenID() {
		return R.drawable.ubica;
	}

	@Override
	public String getElementoPrincipal() {
		return this.getNombre();
	}

	@Override
	public String getElementoSecundario() {
        if(this.getDescripcion() != null && 
           this.getDescripcion().equals("") == false)
      	  return this.getDescripcion() + "\n" + this.getDireccion();
        else
      	  return this.getDireccion();
	}
}
